// I2P_MFC_TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "I2P_MFC_Test.h"
#include "I2P_MFC_TestDlg.h"
#include "Image2PDF.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CI2P_MFC_TestDlg dialog

CI2P_MFC_TestDlg::CI2P_MFC_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CI2P_MFC_TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CI2P_MFC_TestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CI2P_MFC_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CI2P_MFC_TestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CI2P_MFC_TestDlg, CDialog)
	//{{AFX_MSG_MAP(CI2P_MFC_TestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_CONVERT, OnConvert)
	ON_EN_CHANGE(IDC_IMAGE_FILENAME, OnChangeImageFilename)
	ON_EN_CHANGE(IDC_PDF_FILENAME, OnChangePdfFilename)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CI2P_MFC_TestDlg message handlers

BOOL CI2P_MFC_TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CI2P_MFC_TestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CI2P_MFC_TestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CI2P_MFC_TestDlg::ShowError(char *which, UINT iErr)
{
	char message[200];
	
	wsprintf(message, "%s returned error %d", which, iErr);

	MessageBox(message, "Error Returned From Image2PDF DLL", MB_OK | MB_ICONERROR);
}

void CI2P_MFC_TestDlg::OnConvert() 
{

	GetDlgItemText(IDC_IMAGE_FILENAME, imageFilename, MAX_PATH + 1);
	GetDlgItemText(IDC_PDF_FILENAME,   pdfFilename,   MAX_PATH + 1);

	if ((*imageFilename == 0) || (*pdfFilename == 0))
		MessageBox("Please specify both the image and pdf filenames.", "Warning", MB_OK);
	else
	{
		UINT	iErr;
		char	errorText[1024];

		iErr = I2PDF_AddImage(imageFilename);			
		if (iErr) 
			ShowError("I2PDF_AddImage", iErr);
		else
		{
			iErr = I2PDF_SetDPI(0);
			if (iErr)
				ShowError("I2PDF_SetDPI", iErr);
			else
			{
				iErr = I2PDF_MakePDF(pdfFilename, OPTION_OPEN_PDF, errorText, sizeof(errorText));
				if (iErr)
				{
					if (iErr == 3)
						ShowError(errorText, iErr);
					else
						ShowError("I2PDF_MakePDF", iErr);
				}
			}
		}
	}
}

void CI2P_MFC_TestDlg::OnChangeImageFilename() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

void CI2P_MFC_TestDlg::OnChangePdfFilename() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}
