Imports System.Runtime.InteropServices
Imports System.Text

Module Module1
    Declare Auto Function MessageBox Lib "user32.dll" Alias _
        "MessageBox" (ByVal hWnd As Integer, ByVal msg As String, _
        ByVal Caption As String, ByVal Type As Integer) As Integer


    Sub ShowError(ByVal which, ByVal iErr)
        Dim message As String
        message = which + " returned error " + CStr(iErr)
        MessageBox(0, message, "Error Returned From Image2PDF DLL", 0)
    End Sub


    Sub Main()
        Dim iErr As Integer
        Dim imageFilename As String
        Dim pdfFilename As String
        Dim errorText As String = Space(1000)
        Dim errorTextLen As Integer = errorText.Length

        imageFilename = "test.jpg"
        pdfFilename = "test.pdf"

        iErr = Win32.I2PDF_AddImage(imageFilename)
        If (iErr > 0) Then
            ShowError("I2PDF_AddImage", iErr)
            Exit Sub
        End If

        iErr = Win32.I2PDF_SetDPI(96)
        If (iErr > 0) Then
            ShowError("I2PDF_SetDPI", iErr)
            Exit Sub
        End If

        iErr = Win32.I2PDF_MakePDF(pdfFilename, Win32.OPTION_OPEN_PDF, errorText, errorTextLen)
        If (iErr > 0) Then
            If (iErr = 3) Then
                ShowError(errorText, iErr)
            Else
                ShowError("I2PDF_MakePDF", iErr)
            End If
        End If

    End Sub

End Module
